<form class="task-form" [formGroup]="form" *ngIf="!loaded" autocomplete="off">
    <mat-card>
        <mat-card-header>{{name}}</mat-card-header>
        <mat-card-content *ngFor="let field of fieldsList">
            <mat-form-field *ngIf="field.type=='string'">
                <mat-label>{{field.name}}</mat-label>
                <input matInput type="text" [placeholder]="field.name" [formControlName]="field.name" autocomplete="false">
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('required')">
                    Обязательно к заполнению
                </mat-hint>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('minlength')">
                    Вы ввели {{form.get(field.name).errors.minlength.actualLength }} символов. 
                    Требуется ввести не менее {{form.get(field.name).errors.minlength.requiredLength}} символов.
                </mat-hint>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('maxlength')">
                    Вы ввели {{ form.get(field.name).errors.minlength.actualLength }} символов. 
                    Требуется ввести не более {{ form.get(field.name).errors.minlength.requiredLength }} символов.
                </mat-hint>
            </mat-form-field>
            <mat-form-field *ngIf="field.type=='long'">
                <mat-label>{{field.name}}</mat-label>
                <input matInput type="number" [placeholder]="field.name" [formControlName]="field.name">
                <mat-hint *ngIf="form.get(field.name).touched && form.get(field.name).hasError('required')">
                    Обязательно к заполнению
                </mat-hint>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('min')">
                    Текущее значение {{form.get(field.name).errors.min.actual }}. Требуeмое значение должно быть не менее {{ form.get(field.name).errors.min.min }}.
                </mat-hint>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('max')">
                    Текущее значение {{form.get(field.name).errors.max.actual }}. Требуемое значение должно быть не более {{ form.get(field.name).errors.max.max }}.
                </mat-hint>
            </mat-form-field>
            <mat-form-field *ngIf="field.type=='date'">
                <input matInput [matDatepicker]="myDatepicker" [placeholder]="field.name" 
                       [formControlName]="field.name">
                <mat-datepicker-toggle matSuffix [for]="myDatepicker"></mat-datepicker-toggle>
                <mat-datepicker #myDatepicker></mat-datepicker>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('required')">
                    Обязательно к заполнению
                </mat-hint>
            </mat-form-field>
            <!-- <section *ngIf="field.type=='boolean'">
                <mat-checkbox [formControlName]="field.name" [(ngModel)]="field.value">{{ field.name }}</mat-checkbox>
                <mat-hint *ngIf="form.get(field.name).touched && 
                                 form.get(field.name).hasError('required')">
                    Обязательно к заполнению
                </mat-hint>
            </section> -->
        </mat-card-content>
    </mat-card>
    <br>
    <div class="button-row">
        <button (click)="sendForm()" mat-raised-button color="primary"
            [disabled]="form.invalid && fieldsList.length !==0 || submitted">Далее</button>
        <button (click)="closeForm()" mat-raised-button color="primary">Закрыть</button>
    </div>
    
</form>
<mat-spinner *ngIf="loaded"></mat-spinner>
